/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "flags.h"
#include "ggc.h"
#include "hash-set.h"
#include "machmode.h"
#include "vec.h"
#include "double-int.h"
#include "input.h"
#include "alias.h"
#include "symtab.h"
#include "wide-int.h"
#include "inchash.h"
#include "tree.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "rtl.h"
#include "hashtab.h"
#include "hard-reg-set.h"
#include "function.h"
#include "statistics.h"
#include "real.h"
#include "fixed-value.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"
#include "predict.h"

static const char * const output_1[] = {
  "add.n\t%0, %1, %2",
  "addi.n\t%0, %1, %d2",
  "add\t%0, %1, %2",
  "addi\t%0, %1, %d2",
  "addmi\t%0, %1, %x2",
};

static const char * const output_6[] = {
  "mul16s\t%0, %1, %2",
  "mul.aa.ll\t%1, %2",
};

static const char * const output_7[] = {
  "mul16u\t%0, %1, %2",
  "umul.aa.ll\t%1, %2",
};

static const char * const output_11[] = {
  "extui\t%0, %1, 0, %K2",
  "and\t%0, %1, %2",
};

static const char * const output_14[] = {
  "extui\t%0, %1, 0, 16",
  "l16ui\t%0, %1",
};

static const char * const output_15[] = {
  "extui\t%0, %1, 0, 8",
  "l8ui\t%0, %1",
};

static const char * const output_16[] = {
  "sext\t%0, %1, 15",
  "l16si\t%0, %1",
};

static const char *
output_17 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 661 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  int shift;
  if (BITS_BIG_ENDIAN)
    shift = (32 - (INTVAL (operands[2]) + INTVAL (operands[3]))) & 0x1f;
  else
    shift = INTVAL (operands[3]) & 0x1f;
  operands[3] = GEN_INT (shift);
  return "extui\t%0, %1, %3, %2";
}
}

static const char * const output_19[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov.n\t%0, %1",
  "%v1l32i.n\t%0, %1",
  "%v0s32i.n\t%1, %0",
  "%v0s32i.n\t%1, %0",
  "mov\t%0, %1",
  "movsp\t%0, %1",
  "movi\t%0, %x1",
  "const16\t%0, %t1\n\tconst16\t%0, %b1",
  "%v1l32r\t%0, %1",
  "%v1l32i\t%0, %1",
  "%v0s32i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_20[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov\t%0, %1",
  "movi\t%0, %x1",
  "%v1l16ui\t%0, %1",
  "%v0s16i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_21[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov\t%0, %1",
  "movi\t%0, %x1",
  "%v1l8ui\t%0, %1",
  "%v0s8i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_22[] = {
  "mov.s\t%0, %1",
  "%v1lsi\t%0, %1",
  "%v0ssi\t%1, %0",
  "mov.n\t%0, %1",
  "%v1l32i.n\t%0, %1",
  "%v0s32i.n\t%1, %0",
  "mov\t%0, %1",
  "wfr\t%0, %1",
  "rfr\t%0, %1",
  "const16\t%0, %t1\n\tconst16\t%0, %b1",
  "%v1l32r\t%0, %1",
  "%v1l32i\t%0, %1",
  "%v0s32i\t%1, %0",
};

static const char * const output_24[] = {
  "slli\t%0, %1, %R2",
  "ssl\t%2\n\tsll\t%0, %1",
};

static const char * const output_25[] = {
  "srai\t%0, %1, %R2",
  "ssr\t%2\n\tsra\t%0, %1",
};

static const char *
output_26 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1078 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  if (which_alternative == 0)
    {
      if ((INTVAL (operands[2]) & 0x1f) < 16)
        return "srli\t%0, %1, %R2";
      else
      	return "extui\t%0, %1, %R2, %L2";
    }
  return "ssr\t%2\n\tsrl\t%0, %1";
}
}

static const char * const output_27[] = {
  "ssai\t%L2\n\tsrc\t%0, %1, %1",
  "ssl\t%2\n\tsrc\t%0, %1, %1",
};

static const char * const output_28[] = {
  "ssai\t%R2\n\tsrc\t%0, %1, %1",
  "ssr\t%2\n\tsrc\t%0, %1, %1",
};

static const char *
output_29 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1153 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_branch (false, which_alternative == 0, operands);
}
}

static const char *
output_30 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1168 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_branch (true, which_alternative == 0, operands);
}
}

static const char *
output_31 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1183 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_branch (false, which_alternative == 0, operands);
}
}

static const char *
output_32 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1198 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_branch (true, which_alternative == 0, operands);
}
}

static const char *
output_33 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1218 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_bit_branch (false, which_alternative == 0, operands);
}
}

static const char *
output_34 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1236 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_bit_branch (true, which_alternative == 0, operands);
}
}

static const char *
output_35 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1252 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case EQ:		return "bnone\t%0, %1, %2";
    case NE:		return "bany\t%0, %1, %2";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_36 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1273 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case EQ:		return "bany\t%0, %1, %2";
    case NE:		return "bnone\t%0, %1, %2";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_37 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1463 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc (which_alternative == 1, false, false, operands);
}
}

static const char *
output_38 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1493 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc ((which_alternative & 1) == 1,
			    which_alternative >= 2, false, operands);
}
}

static const char *
output_42 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1617 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_call (0, operands);
}
}

static const char *
output_43 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1643 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_call (1, operands);
}
}

static const char *
output_45 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1664 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return TARGET_WINDOWED_ABI ?
      (TARGET_DENSITY ? "retw.n" : "retw") :
      (TARGET_DENSITY ? "ret.n" : "ret");
}
}

static const char *
output_46 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1695 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  return (TARGET_DENSITY ? "nop.n" : "nop");
}
}

static const char *
output_50 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1770 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_DEBUG)
    return "break\t1, 15";
  else
    return (TARGET_DENSITY ? "ill.n" : "ill");
}
}

static const char *
output_51 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1798 "../../gcc/gcc/config/xtensa/xtensa.md"
{
  if (frame_pointer_needed)
    return "mov\ta7, sp";
  return "";
}
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=D,D,a,a,a",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%d,d,r,r,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    add_operand,
    "d,O,r,J,N",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    addsubx_operand,
    "i",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=C,A",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r,r",
    HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a,a",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    mask_operand,
    "P,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a,a",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "r,U",
    HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=a,a",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "r,U",
    QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=B,a",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    sext_operand,
    "r,U",
    HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=a",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    extui_fldsz_operand,
    "i",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "=a,W,a,a,U",
    DImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "r,i,T,U,r",
    DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,D,D,R,R,a,q,a,W,a,a,U,*a,*A",
    SImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,D,d,R,D,d,r,r,I,i,T,U,r,*A,*r",
    SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,a,a,a,U,*a,*A",
    HImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,d,r,I,U,r,*A,*r",
    HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,a,a,a,U,*a,*A",
    QImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,d,r,I,U,r,*A,*r",
    QImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=f,f,U,D,D,R,a,f,a,W,a,a,U",
    SFmode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "f,U,f,d,R,d,r,r,f,iF,T,U,r",
    SFmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=a,W,a,a,U",
    DFmode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "r,iF,T,U,r",
    DFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=a,a",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "J,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    branch_operand,
    "K,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    ubranch_operand,
    "L,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ubranch_operator,
    "",
    VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "J,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a,f,f",
    SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r,r,r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0,f,0",
    SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r,0,f",
    SFmode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    call_insn_operand,
    "nir",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nir",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=r",
    SImode,
    0,
    0,
    0,
    0
  },
  {
    0,
    "",
    BLKmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    DImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "",
    DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    0,
    1,
    0
  },
  {
    constantpool_operand,
    "",
    HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    QImode,
    0,
    0,
    1,
    0
  },
  {
    constantpool_operand,
    "",
    QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&r",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    SFmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    DFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    DFmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    DFmode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "",
    DFmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    BLKmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    BLKmode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_cstoresi_operator,
    "",
    VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SFmode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "",
    SImode,
    0,
    0,
    0,
    0
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:147 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_1 },
#else
    { 0, output_1, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[1],
    3,
    3,
    0,
    5,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:162 */
  {
    "*addx",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "addx%3\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:186 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:196 */
  {
    "*subx",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "subx%3\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:247 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mull\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3 },
    &operand_data[8],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:257 */
  {
    "mulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_6 },
#else
    { 0, output_6, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulhisi3 },
    &operand_data[11],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:271 */
  {
    "umulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_7 },
#else
    { 0, output_7, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulhisi3 },
    &operand_data[11],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:393 */
  {
    "abssi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "abs\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_abssi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:427 */
  {
    "clzsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nsau\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_clzsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:467 */
  {
    "negsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:499 */
  {
    "andsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_11 },
#else
    { 0, output_11, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andsi3 },
    &operand_data[14],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:511 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "or\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorsi3 },
    &operand_data[8],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:521 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xor\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3 },
    &operand_data[8],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:534 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_14 },
#else
    { 0, output_14, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisi2 },
    &operand_data[17],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:545 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_15 },
#else
    { 0, output_15, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqisi2 },
    &operand_data[19],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:571 */
  {
    "extendhisi2_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_16 },
#else
    { 0, output_16, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2_internal },
    &operand_data[21],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:655 */
  {
    "extzv_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_17 },
#else
    { 0, 0, output_17 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extzv_internal },
    &operand_data[23],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:733 */
  {
    "movdi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi_internal },
    &operand_data[27],
    2,
    2,
    0,
    5,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:763 */
  {
    "movsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_19 },
#else
    { 0, output_19, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_internal },
    &operand_data[29],
    2,
    2,
    0,
    15,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:798 */
  {
    "movhi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_20 },
#else
    { 0, output_20, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi_internal },
    &operand_data[31],
    2,
    2,
    0,
    8,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:826 */
  {
    "movqi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_21 },
#else
    { 0, output_21, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi_internal },
    &operand_data[33],
    2,
    2,
    0,
    8,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:898 */
  {
    "movsf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_22 },
#else
    { 0, output_22, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf_internal },
    &operand_data[35],
    2,
    2,
    0,
    13,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1004 */
  {
    "movdf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf_internal },
    &operand_data[37],
    2,
    2,
    0,
    5,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1049 */
  {
    "ashlsi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_24 },
#else
    { 0, output_24, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3_internal },
    &operand_data[39],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1061 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_25 },
#else
    { 0, output_25, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[39],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1073 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_26 },
#else
    { 0, 0, output_26 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[39],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1092 */
  {
    "rotlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_27 },
#else
    { 0, output_27, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_rotlsi3 },
    &operand_data[39],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1104 */
  {
    "rotrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_28 },
#else
    { 0, output_28, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_rotrsi3 },
    &operand_data[39],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1145 */
  {
    "*btrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_29 },
#else
    { 0, 0, output_29 },
#endif
    { 0 },
    &operand_data[42],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1160 */
  {
    "*bfalse",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_30 },
#else
    { 0, 0, output_30 },
#endif
    { 0 },
    &operand_data[42],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1175 */
  {
    "*ubtrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_31 },
#else
    { 0, 0, output_31 },
#endif
    { 0 },
    &operand_data[46],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1190 */
  {
    "*ubfalse",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_32 },
#else
    { 0, 0, output_32 },
#endif
    { 0 },
    &operand_data[46],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1207 */
  {
    "*bittrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_33 },
#else
    { 0, 0, output_33 },
#endif
    { 0 },
    &operand_data[50],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1225 */
  {
    "*bitfalse",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_34 },
#else
    { 0, 0, output_34 },
#endif
    { 0 },
    &operand_data[50],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1243 */
  {
    "*masktrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_35 },
#else
    { 0, 0, output_35 },
#endif
    { 0 },
    &operand_data[54],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1264 */
  {
    "*maskfalse",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_36 },
#else
    { 0, 0, output_36 },
#endif
    { 0 },
    &operand_data[54],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1455 */
  {
    "movsicc_internal0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_37 },
#else
    { 0, 0, output_37 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc_internal0 },
    &operand_data[58],
    5,
    5,
    0,
    2,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1485 */
  {
    "movsfcc_internal0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_38 },
#else
    { 0, 0, output_38 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc_internal0 },
    &operand_data[63],
    5,
    5,
    0,
    4,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1533 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "j\t%l0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[44],
    1,
    1,
    0,
    0,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1555 */
  {
    "indirect_jump_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jx\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump_internal },
    &operand_data[5],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1582 */
  {
    "tablejump_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jx\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump_internal },
    &operand_data[55],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1613 */
  {
    "call_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_42 },
#else
    { 0, 0, output_42 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal },
    &operand_data[68],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1638 */
  {
    "call_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_43 },
#else
    { 0, 0, output_43 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_internal },
    &operand_data[70],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1650 */
  {
    "entry",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "entry\tsp, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_entry },
    &operand_data[26],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1660 */
  {
    "return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_45 },
#else
    { 0, 0, output_45 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1692 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_46 },
#else
    { 0, 0, output_46 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1731 */
  {
    "eh_set_a0_windowed",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_set_a0_windowed },
    &operand_data[73],
    1,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1744 */
  {
    "eh_set_a0_call0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_set_a0_call0 },
    &operand_data[73],
    1,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1760 */
  {
    "blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_blockage },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1767 */
  {
    "trap",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_50 },
#else
    { 0, 0, output_50 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_trap },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1795 */
  {
    "set_frame_ptr",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_51 },
#else
    { 0, 0, output_51 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_set_frame_ptr },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1817 */
  {
    "*unspec_nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1939 */
  {
    "*memory_barrier",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "memw",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[75],
    1,
    1,
    1,
    0,
    1
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:436 */
  {
    "ctzsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ctzsi2 },
    &operand_data[76],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:450 */
  {
    "ffssi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ffssi2 },
    &operand_data[76],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:476 */
  {
    "one_cmplsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplsi2 },
    &operand_data[76],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:559 */
  {
    "extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2 },
    &operand_data[77],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:582 */
  {
    "extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqisi2 },
    &operand_data[79],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:641 */
  {
    "extzv",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extzv },
    &operand_data[81],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:718 */
  {
    "movdi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi },
    &operand_data[85],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:733 */
  {
    "movdi+1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[87],
    0,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:754 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[89],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:789 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[91],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:817 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[93],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:845 */
  {
    "reloadhi_literal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_reloadhi_literal },
    &operand_data[95],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:845 */
  {
    "reloadqi_literal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_reloadqi_literal },
    &operand_data[98],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:879 */
  {
    "movsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf },
    &operand_data[101],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:989 */
  {
    "movdf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf },
    &operand_data[103],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1004 */
  {
    "movdf+1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[105],
    0,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1025 */
  {
    "movmemsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movmemsi },
    &operand_data[107],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1040 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[111],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1121 */
  {
    "cbranchsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsi4 },
    &operand_data[114],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1403 */
  {
    "cstoresi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresi4 },
    &operand_data[118],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1431 */
  {
    "movsicc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc },
    &operand_data[122],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1443 */
  {
    "movsfcc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc },
    &operand_data[126],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1542 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump },
    &operand_data[130],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1564 */
  {
    "tablejump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump },
    &operand_data[131],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1595 */
  {
    "sym_PLT",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_PLT },
    &operand_data[133],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1600 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[134],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1624 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[136],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1676 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1684 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1720 */
  {
    "eh_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_return },
    &operand_data[139],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1731 */
  {
    "eh_return+1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[140],
    0,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1744 */
  {
    "eh_return+2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[140],
    0,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1808 */
  {
    "sym_TPOFF-1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1828 */
  {
    "sym_TPOFF",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_TPOFF },
    &operand_data[133],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1833 */
  {
    "sym_DTPOFF",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_DTPOFF },
    &operand_data[133],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc/gcc/config/xtensa/xtensa.md:1930 */
  {
    "memory_barrier",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_memory_barrier },
    &operand_data[0],
    0,
    0,
    2,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
