/* Generated automatically by the program `genconditions' from the target
   machine description file.  */

#include "bconfig.h"
#include "system.h"

/* It is necessary, but not entirely safe, to include the headers below
   in a generator program.  As a defensive measure, don't do so when the
   table isn't going to have anything in it.  */
#if GCC_VERSION >= 3001

/* Do not allow checking to confuse the issue.  */
#undef ENABLE_CHECKING
#undef ENABLE_TREE_CHECKING
#undef ENABLE_RTL_CHECKING
#undef ENABLE_RTL_FLAG_CHECKING
#undef ENABLE_GC_CHECKING
#undef ENABLE_GC_ALWAYS_COLLECT

#include "coretypes.h"
#include "tm.h"
#include "insn-constants.h"
#include "ggc.h"
#include "rtl.h"
#include "tm_p.h"
#include "hashtab.h"
#include "hash-set.h"
#include "hard-reg-set.h"
#include "function.h"

/* Fake - insn-config.h doesn't exist yet.  */
#define MAX_RECOG_OPERANDS 10
#define MAX_DUP_OPERANDS 10
#define MAX_INSNS_PER_SPLIT 5

#include "regs.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "predict.h"
#include "basic-block.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "tm-constrs.h"

#define HAVE_eh_return 1
#include "except.h"

/* Dummy external declarations.  */
extern rtx_insn *insn;
extern rtx ins1;
extern rtx operands[];

#endif /* gcc >= 3.0.1 */

/* Structure definition duplicated from gensupport.h rather than
   drag in that file and its dependencies.  */
struct c_test
{
  const char *expr;
  int value;
};

/* This table lists each condition found in the machine description.
   Each condition is mapped to its truth value (0 or 1), or -1 if that
   cannot be calculated at compile time.
   If we don't have __builtin_constant_p, or it's not acceptable in array
   initializers, fall back to assuming that all conditions potentially
   vary at run time.  It works in 3.0.1 and later; 3.0 only when not
   optimizing.  */

#if GCC_VERSION >= 3001
static const struct c_test insn_conditions[] = {

#line 224 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_MUL32_HIGH",
    __builtin_constant_p 
#line 224 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_MUL32_HIGH)
    ? (int) 
#line 224 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_MUL32_HIGH)
    : -1 },
#line 1916 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_BOOLEANS",
    __builtin_constant_p 
#line 1916 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_BOOLEANS)
    ? (int) 
#line 1916 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_BOOLEANS)
    : -1 },
#line 801 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "xtensa_valid_move (HImode, operands)",
    __builtin_constant_p 
#line 801 "../../gcc/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (HImode, operands))
    ? (int) 
#line 801 "../../gcc/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (HImode, operands))
    : -1 },
#line 611 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_SEXT",
    __builtin_constant_p 
#line 611 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_SEXT)
    ? (int) 
#line 611 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_SEXT)
    : -1 },
#line 1420 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_HARD_FLOAT",
    __builtin_constant_p 
#line 1420 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT)
    ? (int) 
#line 1420 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT)
    : -1 },
#line 1356 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_LOOPS && optimize && reload_completed",
    __builtin_constant_p 
#line 1356 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize && reload_completed)
    ? (int) 
#line 1356 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize && reload_completed)
    : -1 },
#line 1810 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "reload_completed && !frame_pointer_needed",
    __builtin_constant_p 
#line 1810 "../../gcc/gcc/config/xtensa/xtensa.md"
(reload_completed && !frame_pointer_needed)
    ? (int) 
#line 1810 "../../gcc/gcc/config/xtensa/xtensa.md"
(reload_completed && !frame_pointer_needed)
    : -1 },
#line 1007 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "register_operand (operands[0], DFmode)\n\
   || register_operand (operands[1], DFmode)",
    __builtin_constant_p 
#line 1007 "../../gcc/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DFmode)
   || register_operand (operands[1], DFmode))
    ? (int) 
#line 1007 "../../gcc/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DFmode)
   || register_operand (operands[1], DFmode))
    : -1 },
#line 1707 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_WINDOWED_ABI",
    __builtin_constant_p 
#line 1707 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_WINDOWED_ABI)
    ? (int) 
#line 1707 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_WINDOWED_ABI)
    : -1 },
#line 201 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_ADDX",
    __builtin_constant_p 
#line 201 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_ADDX)
    ? (int) 
#line 201 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_ADDX)
    : -1 },
#line 384 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_DIV32",
    __builtin_constant_p 
#line 384 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_DIV32)
    ? (int) 
#line 384 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_DIV32)
    : -1 },
#line 1750 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "reload_completed",
    __builtin_constant_p 
#line 1750 "../../gcc/gcc/config/xtensa/xtensa.md"
(reload_completed)
    ? (int) 
#line 1750 "../../gcc/gcc/config/xtensa/xtensa.md"
(reload_completed)
    : -1 },
#line 305 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_MAC16",
    __builtin_constant_p 
#line 305 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_MAC16)
    ? (int) 
#line 305 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_MAC16)
    : -1 },
#line 829 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "xtensa_valid_move (QImode, operands)",
    __builtin_constant_p 
#line 829 "../../gcc/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (QImode, operands))
    ? (int) 
#line 829 "../../gcc/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (QImode, operands))
    : -1 },
#line 1955 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_RELEASE_SYNC",
    __builtin_constant_p 
#line 1955 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_RELEASE_SYNC)
    ? (int) 
#line 1955 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_RELEASE_SYNC)
    : -1 },
#line 396 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_ABS",
    __builtin_constant_p 
#line 396 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_ABS)
    ? (int) 
#line 396 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_ABS)
    : -1 },
#line 1663 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "(TARGET_WINDOWED_ABI || !xtensa_current_frame_size) && reload_completed",
    __builtin_constant_p 
#line 1663 "../../gcc/gcc/config/xtensa/xtensa.md"
((TARGET_WINDOWED_ABI || !xtensa_current_frame_size) && reload_completed)
    ? (int) 
#line 1663 "../../gcc/gcc/config/xtensa/xtensa.md"
((TARGET_WINDOWED_ABI || !xtensa_current_frame_size) && reload_completed)
    : -1 },
#line 945 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_HARD_FLOAT && !TARGET_HARD_FLOAT_POSTINC",
    __builtin_constant_p 
#line 945 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && !TARGET_HARD_FLOAT_POSTINC)
    ? (int) 
#line 945 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && !TARGET_HARD_FLOAT_POSTINC)
    : -1 },
#line 766 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "xtensa_valid_move (SImode, operands)",
    __builtin_constant_p 
#line 766 "../../gcc/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (SImode, operands))
    ? (int) 
#line 766 "../../gcc/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (SImode, operands))
    : -1 },
#line 2031 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_S32C1I",
    __builtin_constant_p 
#line 2031 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_S32C1I)
    ? (int) 
#line 2031 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_S32C1I)
    : -1 },
#line 977 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_HARD_FLOAT && TARGET_HARD_FLOAT_POSTINC",
    __builtin_constant_p 
#line 977 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && TARGET_HARD_FLOAT_POSTINC)
    ? (int) 
#line 977 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && TARGET_HARD_FLOAT_POSTINC)
    : -1 },
#line 1850 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_THREADPTR",
    __builtin_constant_p 
#line 1850 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR)
    ? (int) 
#line 1850 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR)
    : -1 },
#line 251 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_MUL32",
    __builtin_constant_p 
#line 251 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_MUL32)
    ? (int) 
#line 251 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_MUL32)
    : -1 },
#line 453 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_NSA",
    __builtin_constant_p 
#line 453 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_NSA)
    ? (int) 
#line 453 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_NSA)
    : -1 },
#line 418 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_MINMAX",
    __builtin_constant_p 
#line 418 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX)
    ? (int) 
#line 418 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX)
    : -1 },
#line 277 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_MUL16 || TARGET_MAC16",
    __builtin_constant_p 
#line 277 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_MUL16 || TARGET_MAC16)
    ? (int) 
#line 277 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_MUL16 || TARGET_MAC16)
    : -1 },
#line 901 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "((register_operand (operands[0], SFmode)\n\
     || register_operand (operands[1], SFmode))\n\
    && !(FP_REG_P (xt_true_regnum (operands[0]))\n\
         && (constantpool_mem_p (operands[1]) || CONSTANT_P (operands[1]))))",
    __builtin_constant_p 
#line 901 "../../gcc/gcc/config/xtensa/xtensa.md"
(((register_operand (operands[0], SFmode)
     || register_operand (operands[1], SFmode))
    && !(FP_REG_P (xt_true_regnum (operands[0]))
         && (constantpool_mem_p (operands[1]) || CONSTANT_P (operands[1])))))
    ? (int) 
#line 901 "../../gcc/gcc/config/xtensa/xtensa.md"
(((register_operand (operands[0], SFmode)
     || register_operand (operands[1], SFmode))
    && !(FP_REG_P (xt_true_regnum (operands[0]))
         && (constantpool_mem_p (operands[1]) || CONSTANT_P (operands[1])))))
    : -1 },
#line 1882 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_THREADPTR && HAVE_AS_TLS",
    __builtin_constant_p 
#line 1882 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR && HAVE_AS_TLS)
    ? (int) 
#line 1882 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR && HAVE_AS_TLS)
    : -1 },
#line 736 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "register_operand (operands[0], DImode)\n\
   || register_operand (operands[1], DImode)",
    __builtin_constant_p 
#line 736 "../../gcc/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DImode)
   || register_operand (operands[1], DImode))
    ? (int) 
#line 736 "../../gcc/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DImode)
   || register_operand (operands[1], DImode))
    : -1 },
#line 1392 "../../gcc/gcc/config/xtensa/xtensa.md"
  { "TARGET_LOOPS && optimize",
    __builtin_constant_p 
#line 1392 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize)
    ? (int) 
#line 1392 "../../gcc/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize)
    : -1 },

};
#endif /* gcc >= 3.0.1 */

int
main(void)
{
  unsigned int i;
  const char *p;
  puts ("(define_conditions [");
#if GCC_VERSION >= 3001
  for (i = 0; i < ARRAY_SIZE (insn_conditions); i++)
    {
      printf ("  (%d \"", insn_conditions[i].value);
      for (p = insn_conditions[i].expr; *p; p++)
        {
          switch (*p)
	     {
	     case '\\':
	     case '\"': putchar ('\\'); break;
	     default: break;
	     }
          putchar (*p);
        }
      puts ("\")");
    }
#endif /* gcc >= 3.0.1 */
  puts ("])");
  fflush (stdout);
return ferror (stdout) != 0 ? FATAL_EXIT_CODE : SUCCESS_EXIT_CODE;
}
